<?php
// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB")){
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

function ultibackup_info(){
	return array(
		"name"			=> "Ultimate Backup Utility",
		"description"	=> "The ultimate backup utility for your MyBB forum!",
		"website"		=> "http://mybbrox.com",
		"author"		=> "Booher",
		"authorsite"	=> "http://mybbrox.com",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "16*"
	);
}
function ultibackup_activate(){
	global $cache, $mybb, $db;
	require_once  MYBB_ROOT."/inc/functions_task.php";
	$new_task = array(
		"title" => $db->escape_string("Ultimate Backup Utility"),
		"description" => $db->escape_string("Checks the specified email for new mail and attempts to post it"),
		"file" => $db->escape_string("ultibackup"),
		"minute" => $db->escape_string("0"),
		"hour" => $db->escape_string("0"),
		"day" => $db->escape_string("*"),
		"month" => $db->escape_string("*"),
		"weekday" => $db->escape_string("3"),
		"enabled" => intval("1"),
		"logging" => intval("1")
	);

	$new_task['nextrun'] = fetch_next_run($new_task);
	$db->insert_query("tasks", $new_task);
	$cache->update_tasks();
}
function ultibackup_deactivate(){
	global $cache, $mybb, $db;
	require_once  MYBB_ROOT."/inc/functions_task.php";

	$db->delete_query("tasks","file='ultibackup'");
	$cache->update_tasks();
}
function ultibackup_is_installed(){
	global $db;
	$query = $db->simple_select("settinggroups","*","name='ultibackup'");
	if($db->num_rows($query) == 1){
		return true;
	}
	return false;
}
function ultibackup_uninstall(){
	global $db;
	$db->delete_query("settinggroups","name='ultibackup'");
	$db->delete_query("settings","name LIKE 'ultibackup_%'");
	rebuild_settings();
}
function ultibackup_install(){
	global $db;
	//settinggroups
	$insert['name'] = 'ultibackup';
	$insert['title'] = 'UltiBackup settings';
	$insert['description'] = 'Settings for the Ultimate Backup System.';
	$insert['disporder'] = 21;
	$db->insert_query('settinggroups',$insert);
	$gid = $db->insert_id();
	$insert = array();

	$insert['name'] = 'ultibackup_local';
	$insert['title'] = 'Keep a local backup';
	$insert['description'] = 'Should we keep a local backup?';
	$insert['optionscode'] = 'yesno';
	$insert['value'] = '1';
	$insert['disporder'] = 1;
	$insert['gid'] = $gid;
	$db->insert_query('settings',$insert);
	
	$insert['name'] = 'ultibackup_email';
	$insert['title'] = 'E-Mail backup';
	$insert['description'] = 'Should we e-mail a copy of the backup to you?';
	$insert['optionscode'] = 'yesno';
	$insert['value'] = '0';
	$insert['disporder'] = 2;
	$insert['gid'] = $gid;
	$db->insert_query('settings',$insert);

	$insert['name'] = 'ultibackup_emailaddr';
	$insert['title'] = 'E-Mail Address';
	$insert['description'] = 'E-Mail address to send backups to';
	$insert['optionscode'] = 'text';
	$insert['value'] = 'you@yoursite.com';
	$insert['disporder'] = 3;
	$insert['gid'] = $gid;
	$db->insert_query('settings',$insert);

	$insert['name'] = 'ultibackup_ftp';
	$insert['title'] = 'Backup to FTP?';
	$insert['description'] = 'Should we create an external backup via FTP?';
	$insert['optionscode'] = 'yesno';
	$insert['value'] = '0';
	$insert['disporder'] = 4;
	$insert['gid'] = $gid;
	$db->insert_query('settings',$insert);

	$insert['name'] = 'ultibackup_ftphost';
	$insert['title'] = 'FTP Host';
	$insert['description'] = 'Host and port of the FTP server you want to create a backup on. If not port is used, the default (21) will be used. Ex: ftp.mysite.com:21';
	$insert['optionscode'] = 'text';
	$insert['value'] = 'localhost:21';
	$insert['disporder'] = 5;
	$insert['gid'] = $gid;
	$db->insert_query('settings',$insert);
	
	$insert['name'] = 'ultibackup_ftpuser';
	$insert['title'] = 'FTP User';
	$insert['description'] = 'Username to connect to the FTP server';
	$insert['optionscode'] = 'text';
	$insert['value'] = 'root';
	$insert['disporder'] = 6;
	$insert['gid'] = $gid;
	$db->insert_query('settings',$insert);
	
	$insert['name'] = 'ultibackup_ftppass';
	$insert['title'] = 'FTP Password';
	$insert['description'] = 'Password for the FTP server';
	$insert['optionscode'] = 'text';
	$insert['value'] = '';
	$insert['disporder'] = 7;
	$insert['gid'] = $gid;
	$db->insert_query('settings',$insert);
	
	$insert['name'] = 'ultibackup_ftppath';
	$insert['title'] = 'FTP File Path';
	$insert['description'] = 'Path to upload the file to. NOTE: This requires a trailing slash.';
	$insert['optionscode'] = 'text';
	$insert['value'] = '/';
	$insert['disporder'] = 8;
	$insert['gid'] = $gid;
	$db->insert_query('settings',$insert);
	rebuild_settings();
}
?>